<template>
    <div id="monitor">

        <div class="row">
            <div class="col-xs-12">
                <div class="box box-nexus">
                    <div class="box-body">
                        <table id="endpointsTable" class="table table-bordered table-striped">
                            <thead>
                            <tr>
                                <th>
                                    #
                                </th>
                                <th>
                                    Url
                                </th>
                                <th>
                                    Frequency
                                </th>
                                <th>
                                    Status
                                </th>
                                <th>
                                    Behavior
                                </th>
                                <th>
                                    Last checked
                                </th>
                                <th>
                                    Action
                                </th>
                            </tr>
                            </thead>
                            <tbody>
                                <template v-for="endpoint in endpoints">

                                    <tr>
                                        <td>
                                            {{ endpoint.id }}
                                        </td>
                                        <td>
                                            {{ endpoint.uri }}
                                        </td>
                                        <td>
                                            {{ endpoint.frequency }}
                                        </td>
                                        <td>
                                            <template v-if="endpoint.status !== null">
                                                <span class="label label-success">
                                                    {{ endpoint.status.status_code }}
                                                </span>
                                            </template>
                                            <template v-else>
                                                <span class="label label-default">
                                                    n/a
                                                </span>
                                            </template>
                                        </td>
                                        <td>
<!--                                            <div class="sparkbar" data-color="#00a65a" data-height="20">90,80,90,-70,61,-83,63</div>-->
                                            <div id="sparklineChart" data-color="#00a65a" data-height="20"></div>
                                        </td>
                                        <td>
                                            {{ endpoint.updated_at }}
                                        </td>
                                        <td class="text-right">
                                            <button type="submit" class="btn-sm btn-danger">
                                                <i class="fa fa-trash-o"></i>
                                            </button>
                                        </td>
                                    </tr>

                                </template>
                            </tbody>
                        </table>
                    </div>
                </div>
            </div>
        </div>

    </div>
</template>

<script>

    // importing Vuex maps
    import { mapActions, mapGetters } from "vuex";

    let every = {
        oneSecond       : 1000,
        twoSeconds      : 2000,
        treeSeconds     : 3000,
        fourSeconds     : 4000,
        oneMinute       : 60000,
        twoMinutes      : 120000,
        threeMinutes    : 180000,
        fourMinutes     : 240000,
        fifteenMinutes  : 900000,
        oneHour         : 3600000,
        twoHour         : 7200000,
        threeHour       : 10800000,
        fourHour        : 14400000
    };

    let sparklineChartData = [200, 200, -404, -404, -404, -404, 200, 300, -404, -404, -404, -404, 200]
    let sparklineChartConfig = {
        type: 'tristate',
        height: '20',
        barWidth: '5',
        barSpacing: '2',
        //barColor: '#7ace4c'
        colorMap: {
            '200:299': 'lightgreen',
            '300:399': 'dodgerblue',
            '-400:-599': 'crimson'
        }
    }

    export default {
        name: "monitor",
        components: {

            // ...

        },
        created() {

            // ...
            this.checkForNewEndpoints()

        },
        mounted() {

            /**
             * @type {jQuery}
             *
             * jQuery Datatables
             * https://datatables.net/
             */
            this.dataTable = $('#endpointsTable').DataTable({
                //"dom": 'lfrtipB',
                "paging":   true,
                "pagingType": "full_numbers",
                "ordering": true,
                "info":     true,
                "lengthMenu": [
                    [
                        14,
                        28,
                        42,
                        -1
                    ],
                    [
                        14,
                        28,
                        42,
                        "All"
                    ]
                ],
                "buttons": [
                    'print', 'excel', 'pdf'
                ],
                "language": {
                    "decimal":          "",
                    "thousands":        ",",
                    "emptyTable":       "No data available in table",
                    "info":             this.locales['view.other.monitor.datatable_info'],
                    "infoEmpty":        this.locales['view.other.monitor.datatable_info_empty'],
                    "infoFiltered":     this.locales['view.other.monitor.datatable_info_filtered'],
                    "infoPostFix":      "",
                    "lengthMenu":       this.locales['view.other.monitor.datatable_length_menu'],
                    "loadingRecords":   "Loading...",
                    "processing":       "Processing...",
                    "search":           "Search:",
                    "zeroRecords":      this.locales['view.other.monitor.datatable_zero_records'],
                    "paginate": {
                        "first":        "First",
                        "last":         "Last",
                        "next":         "Next",
                        "previous":     "Previous"
                    },
                    "aria": {
                        "sortAscending":    ": activate to sort column ascending",
                        "sortDescending":   ": activate to sort column descending"
                    }
                }
            })

            /**
             * @type {jQuery}
             *
             * jQuery Sparklines
             * https://omnipotent.net/jquery.sparkline/#s-about
             */
            this.sparklineChart = $('#sparklineChart').sparkline(sparklineChartData, sparklineChartConfig)

        },
        data() {
            return {

                dataTable: null,
                endpointsCheck: null,
                sparklineChart: null,

            };
        },
        computed: {

            ...mapGetters({
                endpoints: 'monitor/endpoints',
                locales: 'locale/locales'
            })

        },
        methods: {

            ...mapActions({

                fetchEndpoints: 'monitor/fetchEndpoints'

            }),

            checkForNewEndpoints () {
                this.endpointsCheck = setInterval(() => {
                    this.fetchEndpoints()
                }, every.fourSeconds)
            }

        }
    }

</script>

<style lang="scss" scoped>

    // ...

</style>